
<!--- This file is automatically generated by make gen-cli-docs; changes should be made in the go CLI command code (under cmd/kops) -->

## kops create secret weavepassword

Create a weave encryption config.

### Synopsis

Create a new weave encryption secret, and store it in the state store. Used to weave networking to use encrypted communication between nodes. 

If no password is provided, kops will generate one at random. 

WARNING: cannot be enabled on a running cluster without downtime.

```
kops create secret weavepassword [flags]
```

### Examples

```
  # Create a new random weave password.
  kops create secret weavepassword \
  --name k8s-cluster.example.com --state s3://example.com
  # Install a specific weave password.
  kops create secret weavepassword -f /path/to/weavepassword \
  --name k8s-cluster.example.com --state s3://example.com
  # Install a specific weave password via stdin.
  kops create secret weavepassword -f - \
  --name k8s-cluster.example.com --state s3://example.com
  # Replace an existing weavepassword secret.
  kops create secret weavepassword -f /path/to/weavepassword --force \
  --name k8s-cluster.example.com --state s3://example.com
```

### Options

```
  -f, -- string   Path to the weave password file (optional)
      --force     Force replace the kops secret if it already exists
  -h, --help      help for weavepassword
```

### Options inherited from parent commands

```
      --alsologtostderr                  log to standard error as well as files
      --config string                    yaml config file (default is $HOME/.kops.yaml)
      --log_backtrace_at traceLocation   when logging hits line file:N, emit a stack trace (default :0)
      --log_dir string                   If non-empty, write log files in this directory
      --logtostderr                      log to standard error instead of files (default false)
      --name string                      Name of cluster. Overrides KOPS_CLUSTER_NAME environment variable
      --state string                     Location of state storage (kops 'config' file). Overrides KOPS_STATE_STORE environment variable
      --stderrthreshold severity         logs at or above this threshold go to stderr (default 2)
  -v, --v Level                          log level for V logs
      --vmodule moduleSpec               comma-separated list of pattern=N settings for file-filtered logging
```

### SEE ALSO

* [kops create secret](kops_create_secret.md)	 - Create a secret.

